<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum;

/**
 * Class PocetKontrolPodlaStavu
 *
 * @package Seka\Portal\Modul\Statistiky\Models\Zaznam\ValueObjects
 */
final class PocetKontrolPodlaStavu implements PocetKontrol
{
    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum
     */
    private StavEmisnejKontrolyEnum $stav;

    /**
     * @var int
     */
    private int $pocet;

    /**
     * PocetKontrolPodlaStavu constructor.
     *
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum $stav
     * @param int                                                                         $pocet
     */
    public function __construct(StavEmisnejKontrolyEnum $stav, int $pocet)
    {
        $this->stav = $stav;
        $this->pocet = $pocet;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\StavEmisnejKontrolyEnum
     */
    public function stav(): StavEmisnejKontrolyEnum
    {
        return $this->stav;
    }

    /**
     * @return int
     */
    public function pocet(): int
    {
        return $this->pocet;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaStavu $pocetKontrolPodlaStavu
     *
     * @return $this
     */
    public function navysitPocet(self $pocetKontrolPodlaStavu): self
    {
        if (false === $pocetKontrolPodlaStavu->stav->equals($this->stav)) {
            throw new InvalidArgumentException('Navysenie poctu kontrol podla ineho stavu kontroly nie je mozne.');
        }

        return new self(
            $this->stav,
            $this->pocet + $pocetKontrolPodlaStavu->pocet()
        );
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaStavu $pocetKontrolPodlaStavu
     *
     * @return bool
     */
    public function equalsStav(self $pocetKontrolPodlaStavu): bool
    {
        return $this->stav()->equals($pocetKontrolPodlaStavu->stav());
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'stav' => $this->stav->value,
            'pocet' => $this->pocet,
        ];
    }

    /**
     * @return string
     */
    public function jsonSerialize(): string
    {
        return json_encode($this->toArray());
    }
}
